package com.nisum.app.fluxandmono;

import org.junit.jupiter.api.Test;
import reactor.core.publisher.Flux;

public class FluxAndMonoTest {

    //Use case-1 Flux is emitting data successfully
   /* @Test
    public void fluxTest(){
      Flux<String> stringFlux=Flux
              .just("Spring","SpringBoot","Reactive Spring")
              .log();

      stringFlux.subscribe(System.out::println);
    }*/

    //Use case-2 error occured while emitting data
   /* @Test
    public void fluxTest(){
        Flux<String> stringFlux=Flux.just("Spring","SpringBoot","Reactive Spring")
                .concatWith(Flux
                        .error(new RuntimeException("Error occur while emitting data")))
                .log();

        stringFlux
                .subscribe(System.out::println,
                        e-> System.err.println("Exception is: "+e));
    }*/

    //Use case-3 Flux is not going to emit data if error occur in between
    @Test
    public void fluxTest(){
        Flux<String> stringFlux=Flux.just("Spring","SpringBoot","Reactive Spring")
                .concatWith(Flux
                        .error(new RuntimeException("Error occur while emitting data")))
                .concatWith(Flux.just("After error is occured"))
                .log();
        stringFlux
                .subscribe(System.out::println,
                        e-> System.err.println("Exception is: "+e),
                        ()-> System.out.println("Flux emitted completely"));
    }
}
